<template>
  <article class="view view--forum-topic">
    <TopicDetail
      :alias="alias"
      :topic="topic"
      @loaded="onTopicLoaded"
      @subscribed="onSubscribed"
      @unsubscribed="onUnsubscribed"
    />
    <PostList
      :alias="alias"
      :route="topicRoute"
      :offset="offset"
      :limit="limit"
      :postId="postId"
      :opUserId="opUserId"
      view="list"
      :pagination="true"
      :key="latestCreatedPostId"
    />
    <PostCreateForm v-if="showPostCreateForm" :topic="topic" @created="onPostCreated" :key="latestCreatedPostId" />
  </article>
</template>

<script>
import { ref, computed, watch } from 'vue'
import { useRouter, useRoute } from 'vue-router'
import { useStore } from 'vuex'
import { Constants, ValidationHelper } from '../../../core'
import TopicDetail from '../../components/topic-detail.vue'
import PostList from '../../components/post-list.vue'
import PostCreateForm from '../../components/post-create-form.vue'

export default {
  name: 'ForumTopicView',
  components: {
    TopicDetail,
    PostList,
    PostCreateForm,
  },
  setup() {
    const store = useStore()
    const router = useRouter()
    const route = useRoute()

    const topicLoaded = ref(false)
    const topic = ref(undefined)
    const latestCreatedPostId = ref(0) // Used as a key for refreshing the post list.

    const alias = computed(() => {
      return ValidationHelper.getString(route.params.alias, '')
    })

    const offset = computed(() => {
      return ValidationHelper.getInteger(route.query.offset, 0)
    })

    const limit = computed(() => {
      return ValidationHelper.getInteger(route.query.limit, Constants.pagination.defaultPageLimit)
    })

    const postId = computed(() => {
      return ValidationHelper.getInteger(route.query.postId, 0)
    })

    const topicRoute = computed(() => {
      return alias.value ? { name: 'forum-topic', params: { alias: alias.value } } : null
    })

    const opUserId = computed(() => {
      return topic.value ? topic.value.userId : 0
    })

    const iconClass = computed(() => {
      return route.meta.iconClass
    })

    const title = computed(() => {
      return topic.value ? topic.value.title : alias.value
    })

    const showPostCreateForm = computed(() => {
      return topicLoaded.value && canCreatePosts.value
    })

    const canCreatePosts = computed(() => {
      return store.state.identity.session.roles.includes('Member')
    })

    const breadcrumbs = computed(() => {
      return [
        {
          text: 'Forum',
          route: { name: 'forum-forum' },
        },
        {
          text: topic.value?.section?.displayName || 'Section',
          route: topic.value?.section
            ? { name: 'forum-section', params: { codeName: topic.value.section.codeName } }
            : null,
        },
        {
          text: title.value,
          route: null, // No link to self
        },
      ]
    })

    const onTopicLoaded = (topic) => {
      topic.value = topic
      topicLoaded.value = true
    }

    const onSubscribed = () => {
      topic.value.subscribed = true
    }

    const onUnsubscribed = () => {
      topic.value.subscribed = false
    }

    const onPostCreated = (id) => {
      latestCreatedPostId.value = id
      router.push({ hash: `#post${id}` })
    }

    watch(title, (val) => {
      store.dispatch('core/setTitle', val)
    })

    watch(breadcrumbs, (val) => {
      store.dispatch('core/setBreadcrumbs', val)
    })

    store.dispatch('core/setIconClass', iconClass.value)

    return {
      topicLoaded,
      topic,
      latestCreatedPostId,
      alias,
      offset,
      limit,
      postId,
      topicRoute,
      opUserId,
      showPostCreateForm,
      canCreatePosts,
      onTopicLoaded,
      onSubscribed,
      onUnsubscribed,
      onPostCreated,
    }
  },
}
</script>
